
# Load the SOAP service support framework
package require SOAP::Domain


# Use namespaces to isolate your methods
#namespace eval urn:RegisterServer {

    global MIDASRegisterServer
    set MIDASRegisterServer "/Undefined"

    proc DefineServer {p} {
        global MIDASRegisterServer
        puts "called method DefineServer"
        set MIDASRegisterServer $p
        set status ""
        return [rpcvar::rpcvar string $status]
    }

    proc InquireRegisters {p} {
        global MIDASRegisterServer
        puts "called method InquireRegisters"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :pattern '$p' ?names)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc WriteRegister {r v} {
        global MIDASRegisterServer
        puts "called method WriteRegister"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :name '$r' :value '$v')"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc WriteRegisters {p v} {
        global MIDASRegisterServer
        puts "called method WriteRegisters"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :pattern '$p' :value '$v')"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc ReadRegister {r} {
        global MIDASRegisterServer
        puts "called method ReadRegisters"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :name '$r' ?value)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc ReadRegisters {p} {
        global MIDASRegisterServer
        puts "called method ReadRegisters"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :pattern '$p' ?names-and-values)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc InitialiseRegister {r} {
        global MIDASRegisterServer
        puts "called method InitialiseRegister"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :name '$r' !initialise)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc InitialiseRegisters {p} {
        global MIDASRegisterServer
        puts "called method InitialiseRegisters"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :pattern '$p' !initialise)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc WriteRegisterAttributes {r a} {
        global MIDASRegisterServer
        puts "called method WriteRegisterAttributes"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :name '$r' :object '$a')"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc WriteRegistersAttributes {p a} {
        global MIDASRegisterServer
        puts "called method WriteRegistersAttributes"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :pattern '$p' :object '$a')"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc ReadRegisterAttributes {r} {
        global MIDASRegisterServer
        puts "called method ReadRegisterAttributes"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :name '$r' ?object)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc ReadRegistersAttributes {p} {
        global MIDASRegisterServer
        puts "called method ReadRegistersAttributes"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :pattern '$p' ?names-and-objects)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc DefineRegister {r c a} {
        global MIDASRegisterServer
        puts "called method DefineRegister"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :name '$r' !delete)"} m]
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :name '$r' :class '$c' !new)"} m]
        if {!$z} {set z [catch {eg "(register :path '/$MIDASRegisterServer' :name '$r' :object '$a')"} m]}
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc DeleteRegister {r} {
        global MIDASRegisterServer
        puts "called method DeleteRegister"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :name '$r' !delete)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc DeleteRegisters {p} {
        global MIDASRegisterServer
        puts "called method DeleteRegisters"
        set z [catch {eg "(register :path '/$MIDASRegisterServer' :pattern '$p' !delete)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }



    # We have to publish the public methods...

     SOAP::export DefineServer
     SOAP::export DefineRegister
     SOAP::export InquireRegisters
     SOAP::export WriteRegister
     SOAP::export WriteRegisters
     SOAP::export ReadRegister
     SOAP::export ReadRegisters
     SOAP::export InitialiseRegister
     SOAP::export InitialiseRegisters
     SOAP::export WriteRegisterAttributes
     SOAP::export ReadRegisterAttributes
     SOAP::export WriteRegistersAttributes
     SOAP::export ReadRegistersAttributes
     SOAP::export DeleteRegister
     SOAP::export DeleteRegisters


#}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /RegisterServer -namespace urn:RegisterServer -uri urn:RegisterServer]
